﻿Module Module1

   Sub Main()
      Dim zahl As Integer              ' zerlegende Zahl
      Dim teiler As New ArrayList()    ' Liste der ermittelten Teiler

      ' Zahl einlesen
      Console.Write("Geben Sie eine Zahl ein, die in ihre Teiler zerlegt werden soll: ")
      zahl = Integer.Parse(Console.ReadLine())

      ' Zahl zerlegen
      SucheTeiler(zahl, teiler)

      ' Ergebnis ausgeben
      Console.Write("Die Teiler von {0} lauten:", zahl)
      For Each i As Integer In teiler
         Console.Write(" {0}", i)
      Next i
      Console.WriteLine()
   End Sub


   ''' <summary>
   ''' Sucht alle Teiler einer Zahl. Die Funktion arbeitet rekursiv.
   ''' </summary>
   ''' <param name="zahl">Zahl, deren Teiler gesucht werden sollen.</param>
   ''' <param name="teiler">ArrayListe, die die Teiler aufnimmt.</param>
   ''' <remarks></remarks>
   Sub SucheTeiler(ByVal zahl As Integer, ByRef teiler As ArrayList)

      Dim i As Integer = 2    ' Startwert bei der Suche nach Primfaktoren

      Debug.Indent()
      While i <= zahl

         If (zahl Mod i) = 0 Then            ' ist i ein Teiler ?
            Debug.WriteLine("Teiler gefunden: " & i)
            teiler.Add(i)                    ' ja: Teiler in Liste aufnehmen
            SucheTeiler(zahl / i, teiler)    ' Rest der Zahl weiter zerlegen
            Exit While                       ' Diese Ebene der Rekursion stoppen
         End If

         i += 1                              ' Nächste Zahl testen
      End While
      Debug.Unindent()
   End Sub
End Module
