' Wird bentigt fr StringBuilder
Imports System.Text
Module Personen

   ''' <summary>
   ''' Kleines Testprogramm fr die verschiedenen Klassen in diesem Modul.
   ''' </summary>
   Sub Main()

      ' Klasse Person testen
      ' Klassenerstellung, Verwendung der Eigenschaften um Daten anzuzeigen
      Console.WriteLine("--- Klasse Person testen")
      Dim meier As New Person("Karla Meier", 34)
      Console.WriteLine("meier.Name: " & meier.Name)
      Console.WriteLine("meier.Alter: " & meier.Alter)

      ' Verwendung der Set-Prozedur und Anzeige des neuen Namensn
      Console.WriteLine("Namensnderung wird durchgefhrt")
      meier.Name = "Karla Meier-Schmitz"
      Console.WriteLine("meier.Name: " & meier.Name)

      ' Methode Geburtstag verwenden
      Console.WriteLine("Geburtstag von meier ergibt: " & meier.Geburtstag())
      Console.WriteLine("meier.Alter: " & meier.Alter)

      ' Verwenden der berschriebenen Version von ToString
      Console.WriteLine(meier.ToString())
      Console.WriteLine()

      ' Klasse Person2 testen
      Console.WriteLine("--- Klasse Person2 testen")

      Dim mller As New Person2("Fritz", "Mller")
      Console.WriteLine("mller.KompletterName: " & mller.KompletterName)
      Console.WriteLine()

      ' Klasse Lehrer testen 
      Console.WriteLine("--- Klasse Lehrer testen")
      Dim stein As New Lehrer("Karl Stein", 32, "Mathematik")
      Console.WriteLine("stein.Name: " & stein.Name)
      Console.WriteLine("stein.Fach: " & stein.Fach)
      Console.WriteLine("stein.Alter: " & stein.Alter)
      ' Methode Geburtstag verwenden
      Console.WriteLine("Geburtstag von stein ergibt: " & stein.Geburtstag())
      Console.WriteLine("stein.Alter: " & stein.Alter)
      Console.WriteLine()

      ' Auf Taste warten
      Console.ReadKey()
    End Sub

    Public Class Person

        ' ffentliche Konstante, vermeidet das Verwenden von "magischen" Zahlen im Quellcode
        Public Const AlterUndefiniert As Integer = -1

        ' automatisch implementierte Eigenschaft Name
        Public Property Name As String

        ' Feld der Klasse
        Private mAlter As Integer

        ' Konstruktor mit einem String-Parameter
        Public Sub New(ByVal name As String)
            Me.Name = name
            mAlter = AlterUndefiniert
        End Sub

        'berladener Konstruktor mit einem String- und einem Integer-Parameter
        Public Sub New(ByVal name As String, ByVal alter As Integer)
            Me.Name = name
            mAlter = alter
        End Sub

        ' berschriebene Version von ToString
        Public Overrides Function ToString() As String
            Dim sb As New StringBuilder()
            With sb
                ' Implementierung der Basisklassse zuerst aufrufen
                .Append("MyBase.ToString ergibt: ")
                .Append(MyBase.ToString())
                .Append(System.Environment.NewLine)

                ' Hier folgt die eigene Implementierung
                .Append("Die Person heisst: ")
                .Append(Me.Name)
                .Append(". ")

                If mAlter <> AlterUndefiniert Then
                    .Append("Sie ist ")
                    .Append(CStr(Me.mAlter))
                    .Append(" Jahre alt.")
                    .Append(System.Environment.NewLine)
                End If
            End With
            Return sb.ToString()
        End Function

        ' Erhht das Alter um ein Jahr, wenn das Alter bekannt ist
        Public Function Geburtstag() As Boolean
            If mAlter <> AlterUndefiniert Then
                mAlter = mAlter + 1
                Return True
            Else
                Return False
            End If

        End Function

        ' Eigenschaft Alter
        Public Property Alter() As Integer
            Get
                Return mAlter
            End Get
            Set(ByVal value As Integer)
                If mAlter = AlterUndefiniert Then
                    mAlter = value
                Else
                    Throw New System.InvalidOperationException("Das Alter ist bereits definiert.")
                End If
            End Set
        End Property

    End Class

   ' Abgeleitete Klasse
   Public Class Lehrer : Inherits Person

      ' Eigenschaft Fach als automatisch implementierte Eigenschaft 
      Property Fach As String

      ' Konstruktor fr Lehrer mit zwei Parametern, ruft Konstruktor der Basisklasse auf
      Public Sub New(ByVal name As String, ByVal fach As String)
         MyBase.New(name)
         Me.Fach = fach
      End Sub
      ' Konstruktor fr Lehrer mit drei Parametern, ruft Konstruktor der Basisklasse auf
      Public Sub New(ByVal name As String, ByVal alter As Integer, ByVal fach As String)
         MyBase.New(name, alter)
         Me.Fach = fach
      End Sub
   End Class

   Public Class Person2
      ' Klassenvariablen
      Private mVorname As String
      Private mNachname As String

      '  Konstruktor
      Public Sub New(ByVal vorname As String, ByVal nachname As String)
         mVorname = vorname
         mNachname = nachname
      End Sub

      ' Schreibgeschtzte Eigenschaft
      ' Wert dieser Eigenschaft wird anhand von anderen Felder "berechnet"
      Public ReadOnly Property KompletterName() As String
         Get
            Return (mNachname & ", " & mVorname)
         End Get
      End Property

   End Class
  

End Module