Namespace VisualBasicLernen.MetricsConverter
   Public Module Length

      ''' <summary>
      '''  Wandelt die bergebene Lngenangabe in Zentimetern in 
      '''  feet/nches um.
      ''' </summary>
      '''  <param name="feet">feet-Anteil (Ausgabe der Methode)</param>
      '''  <param name="inch">inch-Anteil (Ausgabe der Methode)</param>
      '''  <param name="cm">Lnge in cm</param>
      Sub CmToFeetInch(ByRef feet As Integer, ByRef inch As Integer, ByVal cm As Integer)

         ' zuerst die cm in inches umwandeln
         Dim inches As Double = (cm / 2.54)

         ' inch in feet konvertieren, bei der Division das Abschneiden
         ' des Quotienten in Kauf nehmen
         feet = inches / 12

         ' der Restwert der Division der Gesamtinches durch 12 ergibt
         ' den inch-Anteil. Den Restwert runden lassen.
         inch = Math.Round(inches Mod 12)
      End Sub

      ''' <summary>
      ''' Wandelt die bergebene Lngenangabe aus feet und inch in
      ''' Zentimeter um.
      ''' </summary>
      ''' <param name="feet">Lnge in feet</param>
      ''' <param name="inch">Lnge in inch</param>
      ''' <param name="cm">Lnge in cm (Ausgabe der Methode)</param>
      Sub FeetInchToCm(ByVal feet As Integer, ByVal inch As Integer, ByRef cm As Integer)
         ' 1 ft = 12 inch, zuerst die Lngenangabe in inch umwandeln
         Dim inchTotal As Integer = (12 * feet) + inch

         ' 1 inch = 2,54 cm, bei der Multiplikation das Abschneiden
         ' des Produkts in Kauf nehmen
         cm = 2.54 * inchTotal
      End Sub

   End Module
End Namespace
