﻿Public Class Pencil
    Implements ICreated

    Private mIsDown As Boolean      ' pencil status
    Private mCreated As Date        ' time of object creation

    ''' <summary>
    ''' Default Constructor
    ''' </summary>
    Public Sub New()
        mIsDown = False
        mCreated = Date.Now
    End Sub

    ''' <summary>
    ''' Bring down pencil.
    ''' </summary>
    Public Sub Down()
        mIsDown = True
    End Sub

    ''' <summary>
    ''' Lift pencil
    ''' </summary>
    Public Sub Up()
        mIsDown = False
    End Sub

    ''' <summary>
    ''' Get current pencil status.
    ''' </summary>
    ''' <returns>True: pencil is down; False: pencil is up</returns>
    Public ReadOnly Property IsDown() As Boolean
        Get
            Return mIsDown
        End Get
    End Property

    ''' <summary>
    ''' Returns name of pencil.
    ''' </summary>
    ''' <returns>Name of pencil</returns>
    Public Overrides Function ToString() As String
        Return "Virtual Pencil"
    End Function

    Public ReadOnly Property Created As Date Implements ICreated.Created
        Get
            Return mCreated
        End Get
    End Property
End Class
