Imports System.Text
Imports System.IO


Public Class NotepadForm
   ' Name der Anwendung, fr Text der Titelleiste
   Private mApplicationName As String = "MyNotepad"

   ' Pfad der aktuellen Datei
   Private mCurrentFile As String = ""

   ' wurde TextBox gendert?
   Private mIsModified As Boolean = False



   Private Sub ffnenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ffnenToolStripMenuItem.Click

      ' Prfen, ob das aktuelle Dokument bereits gespeichert ist
      checkModified(sender, e)


      With dlgOpenFile
         .Filter = "Textdateien (*.txt)|*.txt|Alle Dateien(*.*)|*.*"
         .FilterIndex = 1
         .FileName = ""

         Dim dlgResult As DialogResult = .ShowDialog()
         If dlgResult = Windows.Forms.DialogResult.Cancel Then
            Exit Sub
         End If
      End With


      Try
         Dim enc As Encoding
         enc = DetectFileEncoding(dlgOpenFile.FileName)

         ' Inhalt der ausgewhlte Datei in der TextBox anzeigen lassen
         Me.txtEdit.Text = My.Computer.FileSystem.ReadAllText(dlgOpenFile.FileName, enc)

         ' Flag neu initialisieren
         Me.mIsModified = False

         ' Text der Titelleiste des Forms ndern
         Me.Text = My.Computer.FileSystem.GetName(dlgOpenFile.FileName) + " - " + Me.mApplicationName

         ' Kompletten Pfadnamen der aktuellen Datei merken
         Me.mCurrentFile = dlgOpenFile.FileName

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Fehler aufgetreten", _
                         MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
      End Try

   End Sub

   Private Sub txtEdit_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtEdit.TextChanged
      Me.mIsModified = True
   End Sub

   Private Sub SpeichernunterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernunterToolStripMenuItem.Click

      With dlgSaveFile
         ' Eigenschaften des Dialogs initialisieren
         .Filter = "Textdateien (*.txt)|*.txt|Alle Dateien(*.*)|*.*"
         .FilterIndex = 2

         ' Dialog anzeigen lassen
         Dim dlgResult As DialogResult = .ShowDialog()

         ' Ereignishandler beenden, wenn Anwender auf Abbrechen geklickt hat
         If dlgResult = Windows.Forms.DialogResult.Cancel Then
            Return
         End If
      End With


      Try
         ' Dateinamen merken
         Me.mCurrentFile = dlgSaveFile.FileName

         ' Inhalt der TextBox in Datei schreiben
         My.Computer.FileSystem.WriteAllText(dlgSaveFile.FileName, Me.txtEdit.Text, False)

         ' Gendert-Flag zurcksetzen
         Me.mIsModified = False
         ' Titelleiste anpassen
         Me.Text = My.Computer.FileSystem.GetName(dlgSaveFile.FileName) + " - " + Me.mApplicationName
      Catch ex As Exception
         MessageBox.Show(ex.Message, "Fehler aufgetreten", _
                         MessageBoxButtons.OK, MessageBoxIcon.Error)
      End Try

   End Sub

   Private Sub SpeichernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernToolStripMenuItem.Click

      ' noch kein Dateiname vorhanden?
      If Me.mCurrentFile = "" Then
         ' neue Datei speichern lassen
         Me.SpeichernunterToolStripMenuItem_Click(sender, e)
         Exit Sub
      End If

      Try
         My.Computer.FileSystem.WriteAllText(Me.mCurrentFile, Me.txtEdit.Text, False)
      Catch ex As Exception
         MessageBox.Show(ex.Message, "Fehler aufgetreten", MessageBoxButtons.OK, MessageBoxIcon.Error)
      End Try

      Me.mIsModified = False

   End Sub

   Private Sub NeuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeuToolStripMenuItem.Click, NewToolStripButton.Click

      ' Prfen, ob Dokument gendert wurde
      checkModified(sender, e)

      ' Aktuellen Dateinamen zurcksetzen
      Me.mCurrentFile = ""

      ' Inhalt der TextBox lschen            
      Me.txtEdit.Clear()

      ' Titelleiste anpassen
      Me.Text = Me.mApplicationName

      ' Gendert-Flag zurcksetzen
      ' Diese Anweisung MUSS nach dem Aufruf von Me.txtEdit.Clear() stehen, da 
      ' durch den Aufruf von Clear das Ereignis TextChanged ausgelst wird, und im
      ' Eventhandler das Flag dann wieder auf true gesetzt wird
      Me.mIsModified = False
   End Sub
   Private Sub checkModified(ByVal sender As System.Object, ByVal e As System.EventArgs)
      ' wenn aktuelles Dokument noch nicht gespeichert wurde
      If Me.mIsModified = True Then

         ' Benutzer fragen, ob das Dokument gespeicehrt werden soll
         Dim dlgResult As DialogResult
         dlgResult = MessageBox.Show("Mchten Sie das Dokument speichern?", _
                      Me.mApplicationName, _
                      MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)


         If dlgResult = Windows.Forms.DialogResult.Yes Then
            ' Wenn er auf Ja klickt
            ' den Eventhandler fr das Speichern aufrufen
            ' dieser kmmert sich dann um alles Weitere und ruft
            ' evtl. SpeichernunterToolStripMenuItem_Click auf, um einen
            ' Dateinamen anzufordern
            SpeichernToolStripMenuItem_Click(sender, e)

         Else
            ' wenn er auf Nein klickt
            ' Gendert-Flag zurcksetzen
            Me.mIsModified = False
         End If

      End If

   End Sub

   Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
      Me.Close()
   End Sub

   Private Sub NotepadForm_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
      checkModified(sender, Nothing)
   End Sub

   Private Sub AlleauswhlenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AlleauswhlenToolStripMenuItem.Click
      ' Gesamten Inhalt der TextBox markieren
      Me.txtEdit.SelectAll()
   End Sub

   Private Sub AusschneidenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AusschneidenToolStripMenuItem.Click
      Me.txtEdit.Cut()
   End Sub

   Private Sub KopierenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles KopierenToolStripMenuItem.Click
      Me.txtEdit.Copy()
   End Sub

   Private Sub EinfgenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EinfgenToolStripMenuItem.Click
      Me.txtEdit.Paste()
   End Sub

   Private Sub InfoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InfoToolStripMenuItem.Click
      Dim aboutDlg As AboutMyNotepad = New AboutMyNotepad()
      aboutDlg.ShowDialog()
   End Sub

   Private Sub SuchenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SuchenToolStripMenuItem.Click
      Dim dialogResult As DialogResult
      Dim searchForm As SearchForm = New SearchForm()
      dialogResult = searchForm.ShowDialog()

      If dialogResult = Windows.Forms.DialogResult.OK Then

         ' Kontrollkstchen "Gro-/Kleinschreibung beachten" auswerten
         Dim stringComparison As StringComparison
         If searchForm.CaseSensitive = True Then
            stringComparison = stringComparison.CurrentCulture
         Else
            stringComparison = stringComparison.CurrentCultureIgnoreCase
         End If

         ' Der Einfachheit halber immer ab Anfang der TextBox suchen
         Dim i As Integer = Me.txtEdit.Text.IndexOf(searchForm.SearchText, 0, stringComparison)

         ' Suchstring wurde in TextBox gefunden
         If (i > 0) Then
            ' Fundstelle in der TextBox markieren
            Me.txtEdit.Select(i, searchForm.SearchText.Length)
         Else
            MessageBox.Show("Der Suchtext wurde leider nicht gefunden.", Me.mApplicationName, _
                            MessageBoxButtons.OK, MessageBoxIcon.Information)
         End If
      End If
   End Sub

   Private Sub FontToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FontToolStripMenuItem.Click
      ' Neue Instanz von FontDialog erstellen
      Dim fontDialog As New FontDialog()

      ' aktuelle Schriftart der TextBox an das Dialogfeld bergeben
      fontDialog.Font = Me.txtEdit.Font

      ' wenn auf OK geklickt wurde, der TextBox die ausgewhlte 
      ' Schriftart zuweisen
      If fontDialog.ShowDialog() = Windows.Forms.DialogResult.OK Then
         Me.txtEdit.Font = fontDialog.Font
      End If
   End Sub

   Private Sub WordWrapToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WordWrapToolStripMenuItem.Click
      ' Wert umkehren
      txtEdit.WordWrap = Not txtEdit.WordWrap

      ' je nach Wert Hkchen im Men ein- oder ausschalten
      WordWrapToolStripMenuItem.Checked = txtEdit.WordWrap

   End Sub

   Private Sub NotepadForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      WordWrapToolStripMenuItem.Checked = txtEdit.WordWrap
   End Sub

   Private Function DetectFileEncoding(ByVal filename As String) As Encoding
      ' Standardmig die Default-Codierung verwenden (Ansi)
      Dim enc As Encoding = Encoding.Default

      ' Bytereihenfolge-Markierung ermitteln, wenn vorhanden
      ' a) die ersten vier Zeichen einlesen
      Dim arrByte(4) As Byte
      Dim file As New FileStream(filename, FileMode.Open)
      file.Read(arrByte, 0, 4)
      file.Close()

      ' b) Buffer untersuchen und lokale Variable zuweisen
      If arrByte(0) = &HEF AndAlso arrByte(1) = &HBB AndAlso arrByte(2) = &HBF Then
         enc = Encoding.UTF8
      ElseIf arrByte(0) = &HFE AndAlso arrByte(1) = &HFF Then
         enc = Encoding.Unicode
      ElseIf arrByte(0) = 0 AndAlso arrByte(1) = 0 AndAlso arrByte(2) = &HFE AndAlso arrByte(3) = &HFF Then
         enc = Encoding.UTF32
      ElseIf arrByte(0) = &H2B AndAlso arrByte(1) = &H2F AndAlso arrByte(2) = &H76 Then
         enc = Encoding.UTF7
      End If

      ' Codierung zurckgeben 
      Return enc
   End Function

End Class
