Module Module1

    Sub Main()
      audioMethods()
      clipboardMethods()
      clockMethods()
      infoMethods()
      keyboardMethods()
      mouseMethods()
      networkMethods()
      Console.WriteLine("Bitte Taste drcken, um Programm zu beenden...")
      Console.ReadKey()
   End Sub

   Sub audioMethods()
      Console.WriteLine("My.Computer.Audio")
      ' Wiedergabe einer Wavedatei, MP3-Dateien werden nicht untersttzt
      Try
         My.Computer.Audio.Play("c:\wavedatei.wav")
      Catch ex As Exception
         Console.WriteLine(ex.Message)
      End Try

      ' Systemklang wiedergeben, wie er in der Systemsteuerung zugeordnet wurde
      My.Computer.Audio.PlaySystemSound(Media.SystemSounds.Exclamation)

      ' Wiedergabe beenden
      My.Computer.Audio.Stop()
      Console.WriteLine()
   End Sub

   Sub clipboardMethods()
      Console.WriteLine("My.Computer.Clipboard")
      ' Text in Zwischenablage kopieren
      My.Computer.Clipboard.SetText("Dieser Text wird in die Zwischenablage kopiert")
      ' Prfen, ob Text vorhanden ist, wenn ja, dann Text abrufen
      If My.Computer.Clipboard.ContainsText Then
         Console.WriteLine("Die Zwischenablage enthlt Text. Folgender Text ist vorhanden:")
         Console.WriteLine(My.Computer.Clipboard.GetText())
      End If

      ' Prfen, ob Audiodaten vorhanden sind
      If My.Computer.Clipboard.ContainsAudio Then
         Console.WriteLine("Die Zwischenablage enthlt Audio-Daten.")
      Else
         Console.WriteLine("Die Zwischenablage enthlt keine Audio-Daten.")
      End If
      ' Inhalt der Zwischenablage lschen
      My.Computer.Clipboard.Clear()
      Console.WriteLine()


   End Sub
   Sub clockMethods()
      Console.WriteLine("My.Computer.Clock")

      Console.WriteLine("Clock.LocalTime = " & My.Computer.Clock.LocalTime)
      Console.WriteLine("Clock.LocalTime.DayOfWeek = " & My.Computer.Clock.LocalTime.DayOfWeek)
      Console.WriteLine("Clock.LocalTime.Month = " & My.Computer.Clock.LocalTime.Month)
      Console.WriteLine("Clock.LocalTime.ToShortDateString = " & My.Computer.Clock.LocalTime.ToShortDateString())
      Console.WriteLine("Clock.LocalTime.ToLongDateString = " & My.Computer.Clock.LocalTime.ToLongDateString())
      Console.WriteLine("Clock.LocalTime.ToShortTimeString = " & My.Computer.Clock.LocalTime.ToShortTimeString)
      Console.WriteLine()
   End Sub


   Sub infoMethods()
      Console.WriteLine("My.Computer.Info")
      ' Information ber physikalischen und virtuellen Speicher.
      Console.WriteLine("TotalPhysicalMemory: " & My.Computer.Info.TotalPhysicalMemory)
      Console.WriteLine("AvailablePhysicalMemory: " & My.Computer.Info.AvailablePhysicalMemory)
      Console.WriteLine("TotalVirtualMemory: " & My.Computer.Info.TotalVirtualMemory)
      Console.WriteLine("AvailableVirtualMemory: " & My.Computer.Info.AvailableVirtualMemory)

      ' Kultur abrufen, die auf dem Computer installiert ist.
      ' Dies sind vor allem die Lndereinstellungen, die in der Systemsteuerung konfiguriert
      ' werden knnen, und die die Sortierreihenfolge, das Format von Datums- und Zeitangaben 
      ' und die Formatierung von Zahlen beeinflussen.
      ' InstalledUICulture ist ebenfalls ein Datentyp, der weitere Eigenschaften und Methoden zur
      ' Verfgung stellt
      Console.WriteLine("InstalledUICulture: " & My.Computer.Info.InstalledUICulture.ToString)
      Console.WriteLine("InstalledUICulture.DisplayName: " & My.Computer.Info.InstalledUICulture.DisplayName)
      Console.WriteLine("InstalledUICulture.EnglishName: " & My.Computer.Info.InstalledUICulture.EnglishName)
      Console.WriteLine("InstalledUICulture.IsNeutralCulture: " & My.Computer.Info.InstalledUICulture.IsNeutralCulture)
      Console.WriteLine("InstalledUICulture.ThreeLetterISOLanguageName: " & My.Computer.Info.InstalledUICulture.ThreeLetterISOLanguageName)
      Console.WriteLine("InstalledUICulture.ThreeLetterWindowsLanguageName: " & My.Computer.Info.InstalledUICulture.ThreeLetterWindowsLanguageName)
      Console.WriteLine("InstalledUICulture.TwoLetterISOLanguageName: " & My.Computer.Info.InstalledUICulture.TwoLetterISOLanguageName)

      ' Informationen ber das Betriebssystem abrufen
      Console.WriteLine("OSFullName: " & My.Computer.Info.OSFullName)
      Console.WriteLine("OSPlatform: " & My.Computer.Info.OSPlatform)
      Console.WriteLine("OSVersion: " & My.Computer.Info.OSVersion)

      ' Und so erhalten Sie Informationen ber das installierte Service-Pack
      If IsNothing(System.Environment.OSVersion.ServicePack) Then
         Console.WriteLine("Kein Service Pack installiert")
      Else
         Console.WriteLine("Installiertes Service Pack: {0}", Environment.OSVersion.ServicePack)
      End If

      Console.WriteLine()
   End Sub

   Sub keyboardMethods()
      Console.WriteLine("My.Computer.Keyboard")
      ' Status der Sondertasten
      Console.WriteLine("AltKeyDown: " & My.Computer.Keyboard.AltKeyDown)
      Console.WriteLine("CtrlKeyDown: " & My.Computer.Keyboard.CtrlKeyDown)
      Console.WriteLine("ShiftKeyDown: " & My.Computer.Keyboard.ShiftKeyDown)
      ' Status der Feststelltasten
      Console.WriteLine("CapsLock: " & My.Computer.Keyboard.CapsLock)
      Console.WriteLine("NumLock: " & My.Computer.Keyboard.NumLock)
      Console.WriteLine("ScrollLock: " & My.Computer.Keyboard.ScrollLock)
      Console.WriteLine()

   End Sub

   Sub mouseMethods()
      Console.WriteLine("My.Computer.Mouse")
      ' Rechte/linke Maustaste getauscht?
      Console.WriteLine("ButtonsSwapped: " & My.Computer.Mouse.ButtonsSwapped)
      ' Hat die Maus ein Scrollrad?
      Console.WriteLine("WheelExists: " & My.Computer.Mouse.WheelExists)
      If My.Computer.Mouse.WheelExists Then
         ' Anzahl der Zeilen abrufen, um die ein Bildlauf durchgefhrt wird, wenn das Rad
         ' um eine Einbuchtung gedreht wird
         Console.WriteLine("WheelScrollLines: " & My.Computer.Mouse.WheelScrollLines)
      End If
      Console.WriteLine()
   End Sub

   Sub networkMethods()
      Console.WriteLine("My.Computer.Network")
      Console.WriteLine("IsAvailable: " & My.Computer.Network.IsAvailable)
      If My.Computer.Network.IsAvailable Then
         Console.WriteLine("Ping: " & My.Computer.Network.Ping("www.tiefer-einsteigen.de"))
      End If
      Try
         My.Computer.Network.UploadFile("c:\datei.txt", "http://www.zielserver.com/upload.aspx")
         My.Computer.Network.DownloadFile("http://www.zielserver.com/downloads/datei.txt", "C:\datei.txt")
      Catch ex As Exception
         Console.WriteLine(ex.Message)
      End Try
      Console.WriteLine()
   End Sub
End Module
