Imports Microsoft.VisualBasic.FileIO
Module FileSystemSamples

   Sub Main()
      ' Beispiele fr Datei- und Orderoperationen
      FileAndFolderOperations()
      ' Inforamationen ber alle Laufwerke des Computers anzeigen
      DrivesInformation()
      ' Auf Taste warten
      Console.ReadKey()
   End Sub

   Sub DrivesInformation()

      Dim getInfo As System.Collections.ObjectModel.ReadOnlyCollection(Of System.IO.DriveInfo)
      getInfo = FileSystem.Drives
      For Each info As System.IO.DriveInfo In getInfo
         If info.IsReady Then
            Console.WriteLine("Name: " & info.Name)
            Console.WriteLine("VolumeLabel: " & info.VolumeLabel)
            Console.WriteLine("DriveFormat: " & info.DriveFormat)
            Console.WriteLine("DriveType: " & info.DriveType)
            Console.WriteLine("DriveType.ToString: " & info.DriveType.ToString())
            Console.WriteLine("TotalSize: " & info.TotalSize)
            Console.WriteLine("TotalFreeSpace: " & info.TotalFreeSpace)
            Console.WriteLine("AvailableFreeSpace: " & info.AvailableFreeSpace)
            Console.WriteLine("RootDirectory.FullName: " & info.RootDirectory.FullName)
            Console.WriteLine()
         End If

      Next
   End Sub
   Sub FileAndFolderOperations()
      Dim newFolder As String = "C:\VBXTest"
      Dim newFile As String = "kleineDatei.txt"
      Dim fileContent As String = "Das ist der Inhalt der Datei kleineDatei.txt."


      ' FileSystem.CurrentDirectory
      Console.WriteLine("Das aktuelle Verzeichnis ist" & FileSystem.CurrentDirectory)

      ' FileSystem.CombinePath
      ' Kompletten Pfadnamen zusammenbauen
      Dim completePath = FileSystem.CombinePath(newFolder, newFile)

      ' FileSystem.GetParentPath
      ' FileSystem.GetName
      ' Komplette Namen wieder auseinandernehmen
      Console.WriteLine("Der bergeordnete Pfad ist " & FileSystem.GetParentPath(completePath))
      Console.WriteLine("Der Name lautet " & FileSystem.GetName(completePath))

      ' FileSystem.DirectoryExists
      ' Testen, ob Ordner vorhanden ist
      If FileSystem.DirectoryExists(newFolder) Then
         Console.WriteLine("Der Ordner " & newFolder & " ist vorhanden.")
      Else
         Console.WriteLine("Der Ordner " & newFolder & " ist nicht vorhanden.")
      End If

      ' FileSystem.CreateDirectory
      ' Neuen Ordner erstellen
      FileSystem.CreateDirectory(newFolder)

      ' FileSystem.WriteAllText 
      ' Neue Textdatei im neuen Ordner erstellen
      FileSystem.WriteAllText(completePath, fileContent, False)

      ' FileSystem.FileExists
      ' Prfen, ob Datei vorhanden
      If FileSystem.FileExists(completePath) Then
         Console.WriteLine("Die Datei " & completePath & " ist vorhanden.")
         DisplayFileInfo(completePath)
      Else
         Console.WriteLine("Die Datei " & completePath & " ist nicht vorhanden.")
      End If

      ' ReadAllText
      ' Dateiinhalt einlesen und anzeigen
      Console.WriteLine(FileSystem.ReadAllText(completePath, System.Text.Encoding.UTF8))

      ' FileSystem.CopyFile
      Dim destination As String = FileSystem.CombinePath(My.Computer.FileSystem.SpecialDirectories.Temp, newFile)
      FileSystem.CopyFile(completePath, destination)
      FileSystem.DeleteFile(destination)

      ' DeleteDirectory
      ' Ordner wieder lschen
      FileSystem.DeleteDirectory(newFolder, DeleteDirectoryOption.DeleteAllContents)
   End Sub

   Private Sub DisplayFileInfo(ByVal fileName As String)
      Dim fileInfo As System.IO.FileInfo
      fileInfo = FileSystem.GetFileInfo(fileName)
      Console.WriteLine("FileSystem.GetFileInfo")
      ' Infos ber Namen und Verzeichnisse
      Console.WriteLine("fileInfo.Name: " & fileInfo.Name)
      Console.WriteLine("fileInfo.FullName: " & fileInfo.FullName)
      Console.WriteLine("fileInfo.Directory: " & fileInfo.Directory.ToString())
      Console.WriteLine("fileInfo.DirectoryName: " & fileInfo.DirectoryName)
      Console.WriteLine("fileInfo.Extension: " & fileInfo.Extension)
      ' Verschiedene Attribute
      Console.WriteLine("fileInfo.Length: " & fileInfo.Length)
      Console.WriteLine("fileInfo.IsReadOnly: " & fileInfo.IsReadOnly)
      Console.WriteLine("fileInfo.Attributes: " & fileInfo.Attributes)
      Console.WriteLine("fileInfo.Attributes.ToString: " & fileInfo.Attributes.ToString())
      ' Datum/Zeit der Erstellung und der Zugriffe
      Console.WriteLine("fileInfo.CreationTime: " & fileInfo.CreationTime)
      Console.WriteLine("fileInfo.LastAccessTime: " & fileInfo.LastAccessTime)
      Console.WriteLine("fileInfo.LastWriteTime: " & fileInfo.LastWriteTime)
      Console.WriteLine()
   End Sub
End Module
