''' <summary>
''' Stellt einen Kreis dar.
''' </summary>
Public Class Kreis
   Implements ICreated

   Private x As Double             ' X-Koordinate des Kreismittelpunktes 
   Private y As Double             ' y-Koordinate des Kreismittelpunktes 
   Private r As Double             ' Kreisradius

   Private mCreated As Date        ' Zeitpunkt der Objekterstellung

   Public Sub New()                ' Standardkonstruktor
      Me.x = 0
      Me.y = 0
      Me.r = 1
      Me.mCreated = Date.Now
   End Sub

   ''' <summary>
   ''' Konstruktor
   ''' </summary>
   ''' <param name="XWert">X-Koordinate des Kreismittelpunkts</param>
   ''' <param name="YWert">Y-Koordinate des Kreismittelpunkts</param>
   ''' <param name="Radius">Kreisradius</param>
   Public Sub New(ByVal XWert As Double, ByVal YWert As Double, ByVal Radius As Double)
      Me.x = XWert
      Me.y = YWert
      Me.r = Radius
      Me.mCreated = Date.Now
   End Sub

   ''' <summary>
   ''' Gibt den Mittelpunkt und den Radius des Kreises als Zeichenfolge aus.
   ''' </summary>
   Public Overrides Function ToString() As String
      Return "Kreis: Mittelpunkt = (" & Me.x & "|" & Me.y & "), Radius = " & Me.r
   End Function

   Public ReadOnly Property Created() As Date Implements ICreated.Created
      Get
         Return mCreated
      End Get
   End Property

   Public ReadOnly Property Age() As Long Implements ICreated.Age
      Get
         Dim ts As TimeSpan
         ts = DateTime.Now - Me.Created
         Return ts.TotalMilliseconds
      End Get
   End Property

End Class