Public Class Form1

   Private Sub linkMainFormText_LinkClicked_1(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles linkMainFormText.LinkClicked
      Dim appContext As ApplicationContext = My.Application.ApplicationContext
      MsgBox("appContext.MainForm.Text = " & appContext.MainForm.Text)
   End Sub

   Private Sub linkSaveSettings_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles linkSaveSettingsOnExit.LinkClicked
      MsgBox("Application.SaveMySettingsOnExit = " & My.Application.SaveMySettingsOnExit)
   End Sub

   Private Sub linkOpenForms_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles linkOpenForms.LinkClicked
      Dim sb As New System.Text.StringBuilder
      With sb
         ' Anzahl der geffneten Forms ausgeben
         .Append("Application.OpenForms.Count = " & My.Application.OpenForms.Count)
         .Append(System.Environment.NewLine)

         ' Auflisung OpenForms durchlaufen und die Eigenschaft Text ausgeben
         For Each f As Form In My.Application.OpenForms
            .Append("Form.Text= ")
            .Append(f.Text)
            .Append(System.Environment.NewLine)
         Next
         MsgBox(.ToString())
      End With
   End Sub

   Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      createComputerLabelText()
      createUserLabelText()
      createDirectoriesLabelText()
      ' nderunng aus bung 16.2
      createDrivesInfo()
   End Sub
   ''' <summary>
   ''' Erstellt anhand der Informationen aus My.Computer eine Zeichenekette
   ''' und weist diese dem Label-Steuerelemente lblComputer zu.
   ''' </summary>
   Private Sub createComputerLabelText()
      Dim sb As New System.Text.StringBuilder()

      With sb
         ' Lokale Zeit abrufen
         .Append("My.Computer.Clock.LocalTime = ")
         .Append(My.Computer.Clock.LocalTime)
         .Append(System.Environment.NewLine)

         '  Anzahl der Millisekunden seit dem letzten Start des Computers 
         .Append("My.Computer.Clock.TickCount = ")
         .Append(My.Computer.Clock.TickCount)
         .Append(System.Environment.NewLine)

         ' Betriebssystem abrufen
         .Append("My.Computer.Info.OSPlatform = ")
         .Append(My.Computer.Info.OSPlatform)
         .Append(System.Environment.NewLine)

         ' Status der Strg-Taste abrufen
         .Append("My.Computer.Keyboard.CtrlKeyDown = ")
         .Append(My.Computer.Keyboard.CtrlKeyDown)
         .Append(System.Environment.NewLine)

         ' Hat die Maus ein Rad?
         .Append("My.Computer.Mouse.WheelExists = ")
         .Append(My.Computer.Mouse.WheelExists)
         .Append(System.Environment.NewLine)

         ' Name des Computers
         .Append("My.Computer.Name = ")
         .Append(My.Computer.Name)
         .Append(System.Environment.NewLine)

         ' Netzwerk verfgbar
         .Append("My.Computer.Network.IsAvailable = ")
         .Append(My.Computer.Network.IsAvailable)
         .Append(System.Environment.NewLine)

         ' zusammengestellten Text im Label-Steuerelement lblComputer anzeigen
         Me.lblComputer.Text = .ToString()
      End With
   End Sub
   ''' <summary>
   ''' Erstellt anhand der Informationen aus My.User eine Zeichenekette
   ''' und weist diese dem Label-Steuerelemente lblUser zu.
   ''' </summary>
   Private Sub createUserLabelText()
      Dim sb As New System.Text.StringBuilder()

      With sb
         ' User.Name abrufen
         .Append("My.User.Name = ")
         .Append(My.User.Name)
         .Append(System.Environment.NewLine)

         ' User.IsAuthenticated abrufen
         .Append("My.User.IsAuthenticated = ")
         .Append(My.User.IsAuthenticated)
         .Append(System.Environment.NewLine)

         ' Wenn Windows-Authenfizierung verwendet wird
         If TypeOf My.User.CurrentPrincipal Is Security.Principal.WindowsPrincipal Then
            .Append("Windows-Authentifizerung wird verwendet.")
            .Append(System.Environment.NewLine)

            ' User.Name in Namen und Domain-Anteil aufteilen
            Dim parts() As String = Split(My.User.Name, "\")
            .Append("Domain des Benutzers: ")
            .Append(parts(0))
            .Append(System.Environment.NewLine)
            .Append("Anmeldename des Benutzers: ")
            .Append(parts(1))
            .Append(System.Environment.NewLine)
         End If

         ' Informationen in lblUser anzeigen
         Me.lblUser.Text = .ToString()
      End With
   End Sub
   ''' <summary>
   ''' Ruft anhand von My.Computer.FileSystem.SpecialDirectories die Pfadnamen
   ''' der verschiedenen Speziallordner ab weist diese dem Label-Steuerelemente lblDirectories zu.
   ''' </summary>
   Private Sub createDirectoriesLabelText()
      Dim sb As New System.Text.StringBuilder()

      With sb
         ' Ordner mit den Anwendungsdaten fr alle Benutzer der aktuellen Anwendung
         .Append("AllUsersApplicationData = ")
         .Append(My.Computer.FileSystem.SpecialDirectories.AllUsersApplicationData)
         .Append(System.Environment.NewLine)

         ' Ordner mit den Anwendungsdaten fr aktuellen Benutzer der aktuellen Anwendung
         .Append("CurrentUserApplicationData = ")
         .Append(My.Computer.FileSystem.SpecialDirectories.CurrentUserApplicationData)
         .Append(System.Environment.NewLine)

         ' Ordner mit dem Desktop
         .Append("Desktop = ")
         .Append(My.Computer.FileSystem.SpecialDirectories.Desktop)
         .Append(System.Environment.NewLine)

         ' Ordner "Eigene Dokumente"
         .Append("MyDocuments = ")
         .Append(My.Computer.FileSystem.SpecialDirectories.MyDocuments)
         .Append(System.Environment.NewLine)

         ' Ordner "Eigene Musik"
         .Append("MyMusic = ")
         .Append(My.Computer.FileSystem.SpecialDirectories.MyMusic)
         .Append(System.Environment.NewLine)

         ' Ordner "Eigene Bilder"
         .Append("MyPictures = ")
         .Append(My.Computer.FileSystem.SpecialDirectories.MyPictures)
         .Append(System.Environment.NewLine)

         ' Ordner, in dem die Programme installiert sind
         ' Bei Windows XP standardmig der Ordner C:\Programe
         .Append("ProgramFiles = ")
         .Append(My.Computer.FileSystem.SpecialDirectories.ProgramFiles)
         .Append(System.Environment.NewLine)

         ' Ordner mit dem Startmen des aktuellen Benutzers
         .Append("Programs = ")
         .Append(My.Computer.FileSystem.SpecialDirectories.Programs)
         .Append(System.Environment.NewLine)

         ' Ordner mit temporren Dateien
         .Append("Temp = ")
         .Append(My.Computer.FileSystem.SpecialDirectories.Temp)
         .Append(System.Environment.NewLine)

         Me.lblSpecialDirectories.Text = .ToString()
      End With
   End Sub
   ''' <summary>
   ''' Ruft anhand von My.Computer.FileSystem.Drives Informationen zu den 
   ''' Laufwerken des Computers ab und zeigt diese an.
   ''' </summary>
   ''' <remarks>nderunng aus bung 16.2</remarks>
   Sub createDrivesInfo()
      Dim getInfo As System.Collections.ObjectModel.ReadOnlyCollection(Of System.IO.DriveInfo)
      Dim sb As New System.Text.StringBuilder()
      getInfo = My.Computer.FileSystem.Drives
      For Each info As System.IO.DriveInfo In getInfo
         If info.IsReady Then
            With sb
               .Append("Name: " & info.Name & vbNewLine)
               .Append("VolumeLabel: " & info.VolumeLabel & vbNewLine)
               .Append("DriveFormat: " & info.DriveFormat & vbNewLine)
               .Append("DriveType: " & info.DriveType & vbNewLine)
               .Append("DriveType.ToString: " & info.DriveType.ToString() & vbNewLine)
               .Append("TotalSize: " & info.TotalSize & vbNewLine)
               .Append("TotalFreeSpace: " & info.TotalFreeSpace & vbNewLine)
               .Append("AvailableFreeSpace: " & info.AvailableFreeSpace & vbNewLine)
               .Append("RootDirectory.FullName: " & info.RootDirectory.FullName & vbNewLine)
               .Append(vbNewLine)
            End With
         End If
      Next

      Me.txtDrives.Text = sb.ToString()
   End Sub
End Class
